Subject: Re: [net PATCH] skb: Do mix page pool and page referenced frags in GRO

From: Toke Høiland-Jørgensen <[email-masked]>
Date: Thu, 26 Jan 2023 20:14:02 +0100

Alexander Duyck <[email-masked]> writes:

> From: Alexander Duyck <[email-masked]>
>
> GSO should not merge page pool recycled frames with standard reference
> counted frames. Traditionally this didn't occur, at least not often.
> However as we start looking at adding support for wireless adapters there
> becomes the potential to mix the two due to A-MSDU repartitioning frames in
> the receive path. There are possibly other places where this may have
> occurred however I suspect they must be few and far between as we have not
> seen this issue until now.
>
> Fixes: 53e0961da1c7 ("page_pool: add frag page recycling support in page pool")
> Reported-by: Felix Fietkau <[email-masked]>
> Signed-off-by: Alexander Duyck <[email-masked]>

I know I'm pattern matching a bit crudely here, but we recently had
another report where doing a get_page() on skb->head didn't seem to be
enough; any chance they might be related?

See: https://lore.kernel.org/r/Y9BfknDG0LXmruDu@JNXK7M3

-Toke